<!--Last Edit on May 21, 2023 -->
# Release Notes for NCID 1.14

[TOC]

## Overall System Requirements

> * Google libphonenumber integration
>> - libphonenumber version 7 or higher
>> - libicu version 67 or higher

> * ncid client and output modules
>> - TCL/TK version 8.6.6 or higher for ncid client and output modules

> * Operating System versions for NCID 1.12 and higher
>> If no minimum version is specified below, we're not aware of any limitations.  
>>
>> Unless specified, 32bit and higher processors are supported.
> 
>> - Cygwin is no longer supported
>> - FreeBSD
>> - Macintosh OS X* 10.9.5 (Mavericks) or higher  using XQuartz, Intel 64bit processors only
>> - Debian based OS
>>> - Debian Stretch (version 9) or higher
>>> - Raspbian* Stretch (version 9) or higher, 32bit processors only
>>> - Ubuntu
>> - RPM based OS
>>> - Fedora
>>> - Redhat
>>> - CentOS

>>> \* We're aware of operating system name changes but not all of our documentation has been updated yet:
>>>> \- Macintosh OS X became macOS as of June 13, 2016  
>>>> \- Raspbian became raspios (Raspberry Pi OS) as of May 29, 2020  


## NCID Distributions

> * SourceForge
> * Cygwin Windows package
> * FreeBSD package
> * Macintosh OS X package
> * Windows client installer
> * Debian based OS packages
>> * Debian
>> * raspios (Raspberry Pi)
>> * Ubuntu
> * RPM based OS packages
>> * Fedora
>> * Redhat
>> * CentOS

> ### SourceForge

          * NCID source package:           ncid-1.14-src.tar.gz

          * Cygwin Windows package:        not available

          * FreeBSD 64 bit package:        ncid-1.14-FreeBSD_install.sh

          * Macintosh 64 bit OS X package: not available

          * Windows client installer:      ncid-1.14-client_windows_setup.exe

          * Debian based OS packages
            ------------------------

                 Debian 64 bit packages:   ncid_1.14-1_amd64.deb
                                           ncid-gateways_1.14-1_amd64.deb

                 Debian no-arch packages:
                                           ncid-client_1.14-1_all.deb
                                           ncid-kpopup_1.14-1_all.deb
                                           ncid-mysql_1.14-1_all.deb
                                           ncid-mythtv_1.14-1_all.deb
                                           ncid-samba_1.14-1_all.deb
                                           ncid-speak_1.14-1_all.deb

                 raspios 32 bit packages: ncid_1.14-1_armhf.deb
                                           ncid-gateways_1.14-1_armhf.deb


          * RPM based OS packages
            ---------------------

                 RPM source package:       ncid-1.14-1.fc37.src.rpm

                 RPM 64 bit packages:      ncid-1.14-1.fc37.x86_64.rpm
                                           ncid-gateways-1.14-1.fc37.x86_64.rpm

                 RPM no-arch packages:     ncid-client-1.14-1.fc37.noarch.rpm
                                           ncid-kpopup-1.14-1.fc37.noarch.rpm
                                           ncid-mysql-1.14-1.fc37.noarch.rpm
                                           ncid-mythtv-1.14-1.fc37.noarch.rpm
                                           ncid-samba-1.14-1.fc37.noarch.rpm
                                           ncid-speak-1.14-1.fc37.noarch.rpm


> ### Cygwin Windows package

>> Not available. Cygwin does not provide the necessary library dependencies for libphonenumber.

> ### FreeBSD package

>> Available at FreshPorts.
>>
>>> https://www.freshports.org/comms/ncid/

> ### Macintosh OS X package

>> Not available. Library dependencies can only be resolved by compiling from source.

<!--
>> The version available at MacPorts is 0.83 which was released
>> October 2011. It is not currently maintained:
>>
>>> https://trac.macports.org/browser/trunk/dports/net/ncid/Portfile
>>
>> Use the version available at SourceForge.
-->

> ### Windows client installer

>> Use the version available at SourceForge.

> ### Debian based OS packages

>>#### Install from repositories:

>>> There are currently no known Debian repositories that host NCID.

<!--
>>> A new release of NCID is first available at Sourceforge. Some time later it is
   available at the Debian repositories.

>>> The install packages include the server, client, optional gateway packages and
   optional output module packages.  Normally you only need to install the **ncid**
   and **ncid-client** deb packages.  The **ncid-gateways** can be installed
   if needed.

>> The apt-cache search command will show you the packages available:
>>
          apt-cache search ncid\*
-->
>> ####  Install from the files at SourceForge:
>>
    - Download the latest NCID DEB packages from SourceForge:
      ncid DEB Package          - server, extensions and tools
      ncid-client DEB Package   - client and default output modules
                                  (if using this client)
      ncid-gateways DEB Package - gateways (if using a gateway)
>>
    - Download any optional output modules wanted:
      ncid-MODULE DEB Package   - optional client output modules
>>
    - Install or Upgrade the packages using apt or apt-get (command line):
        * Install the NCID server and gateways:
          sudo apt install ./ncid-<version>_<processor>.deb
        * Install the client package and default modules:
          sudo apt install ./ncid-client-<version>_all.deb
        * Install any optional modules:
          sudo apt install ncid-<module>-<version>_all.deb
>>
    Notes:
        <version> would be something like: 1.14-1
        <processor> would be: i386, armhf, amd64
        <module> would be: kpopup, mysql, mythtv, samba, speak

>> #### Build a package for your specific Debian based OS or release

>>> The build-essential, fakeroot and libpcap packages must be installed:
>>
          sudo apt-get build-essential fakeroot libpcap0.8-dev
          tar -xzf ncid-1.14-src.tar.gz
          mv ncid ncid-1.14
          cd ncid-1.14
          fakeroot Debian/rules build
          fakeroot Debian/rules binary
          fakeroot Debian/rules clean


> ### RPM based OS packages

>>#### Install from repositories:

>>> A new release of NCID is first available at Sourceforge. Some time later it is available
   at the Fedora or other RPM repositories which includes the Rawhide repository for 
   the next Fedora release.

>> The install packages include the server, client, optional gateway packages and
   optional output module packages.  Normally you only need to install the **ncid**
   and **ncid-client** rpm packages.  The **ncid-gateways** can be installed
   if needed.

>> The dnf list command will show you the packages available:
>>
          dnf list ncid\*

>> If the above does not show version 1.14:
>>
          dnf --enablerepo=rawhide list ncid\*

>> If the rawhide repo is not installed:
>>
          dnf install fedora-release-rawhide

>> #### Build a package for your specific RPM based OS or release

>>> The rpmbuild package must be installed:
>>
          rpmbuild -tb ncid-1.14-src.tar.gz


>> If a dependency can not be resolved, you should try rebuilding packages:
>>
    - Download the latest NCID RPM packages from Sourceforge:
      ncid RPM Package          - server, extensions and tools
      ncid-gateways RPM Package - gateways (if using a gateway)
      ncid-client RPM Package   - client and default output modules
                                  (if using this client)
    - Download any optional output modules wanted:
      ncid-MODULE RPM Package  - optional client output modules
    - Install or Upgrade the packages using dnf
          * Install the NCID server and gateways:
            sudo dnf install ncid-<version>.fc37.x86_64.rpm
          * Install the client package and default modules:
            sudo dnf install ncid-client-<version>.fc37.noarch.rpm
          * Install any optional modules wanted:
            sudo dnf ncid-<module>-<version>.fc37.noarch.rpm
>>
    Notes:
        <version> would be something like: 1.14-1
        <module> would be: kpopup, mysql, mythtv, samba, speak


## Server Changes

> ncidd:

>- updated libpcre to libpcre2
>- improved modem locking
>- improved comments
>- increased call log size from 110,000 to 1,000,000

> ncidd.conf:

>- changed default call log size from 110,000 to 1,000,000
>- added 2 log message statements

> ncidd.blacklist:

> ncidd.whitelist:

> modemhdr.conf:

## Service Files Changes

> artech2ncid.service

>- new

> cideasy2ncid.service

>- new

## Server Extensions Changes

> hangup-calls:

> hangup-closed-skel:

> hangup-combo-skel:

> hangup-fakenum:

>- added "SPAM RISK"
>- cleaned up script

> hangup-fcc:

> hangup-greylist:

> hangup-message-skel:

> hangup-nohangup:

> hangup-skel:

## Udev Files Changes (Linux Only)

## Gateway Changes

> artech2ncid:

> - new

> cideasy2ncid:

> - new

>email2ncid:

> ncid2ncid:

>- fixed 1 long option
>- added API log line at start

> obincid:

> rn2ncid:

> sip2ncid:

>- fixed 2 long options
>- added API log line at start

> wc2ncid:

>- added log line
>- improved some parts of the code

>- improved code

> xdmf2ncid:

> yac2ncid:

## Client Changes

> ncid:

>- Updated the Tablelist library from version 6.18 to 6.21
>- duration calculations can be for **call Time** or **Talk Time**
>- added plugins and context plugins menu items
>- added name or partial name search in history window
>- added help for Autostart, Dial, and Plugins,
>- changed Logo from GIF to PNG with added colors
>- fixed dialer bug

> ncid.conf:

>- reformatted text
>- added Script and Plugin sections
>- added disable_server_dialer when using an external dialer.
>- added comments on User defined optional scripts or programs

## Client Output Module Changes

>- corrected number of lines in input for all modules

## Client Plugins Changes (new)

>- added plugins menu item: "Hello World"
>- added context menu plugin item: Display ncid_variables
>- added context menu item: Check NANP Number

## Client Desktop Changes

>- updated cid desktop file
>- updated appstream metainfo data
>- updated appstream screenshots

## Setup Scripts Changes

>- improved ncid-setup

## Tools Changes

> cidalias:

> cidcall:

> cidupdate:

.- minor fix

>- fixed, broke in 1.13

> get-areacodes-list:

> get-fcc-list:

> ncidnumberinfo:

> ncidutil:

> ncid-yearlog:

> phonetz:

> update-cidcall:

>- rewrote script

> wct:

## Screenshots Changes

>- added ncid-search.png
## Documentation Changes

> Updated Manual Pages:


>- almost all man pages

> new man pages:

>- artech2ncid
>- cideasy2ncid

> Updated User Manual:

>- almost all sections  
(including all INSTALL sections)

> Updated API:

